﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Timers;
using static System.Formats.Asn1.AsnWriter;
using static System.Runtime.InteropServices.JavaScript.JSType;



namespace fdsgfd
{
    class Program
    {
        static char v = 'Ж';
        static char o = '*'; 
        static int width = 41; //длина поля
        static int height = 21; //высота поля
        static char[,] field = new char[height, width]; //массив для вывода в консоль
        static int score = 0; //количество пойманных муравьев
        static string itemM;

        static int aeX, aeY;

        static List<ah> anthills = new List<ah>();
        static List<Ant> ants = new List<Ant>();
        static List<Obstacle> obstacles = new List<Obstacle>();

        static System.Timers.Timer timerAnt;

        static string[] menu = { "1. Играть", "2. Правила", "3. Выход", "Введите номер пункта меню", "и нажмите Enter" };
        static string[] rules = {"Описание игры:", "Вы играете за муравьеда,", "которому необходимо", "ловить муравьев.",
            "Если муравей убежал за поле,", "то он считается сбежавшим.", " ","Управление муравьедом:", "используйте стрелки клавиатуры.", "",
            "Обозначения:", "Ж - забор; О - муравьед;", "Х - муравейники; ° - муравьи;", "* - препятствие для муравьеда", "", "(Нажмите клвишу Enter", "для выхода в меню)"};

        static void Main()
        {
            do
            {
                Frame();
                Menu();
                WriteField();
                Console.SetCursorPosition((width - menu[1].Length) / 2, height - menu.Length);

                itemM = Console.ReadLine();

                Console.Clear();
                FieldClear();

                if (itemM == "2")
                {
                    Frame();
                    Rules();
                    WriteField();
                    Console.ReadLine();
                }

                if (itemM == "3")
                {
                    Environment.Exit(0);
                }

                Console.Clear();
                FieldClear();
            } while (itemM != "1");


            StartTimer();

            Console.CursorVisible = false;

            Console.WindowWidth = width;
            Console.WindowHeight = height + 20;
            Console.BufferWidth = width;
            Console.BufferHeight = height + 20;


            Frame();
            //создание массива поля с объектами игры
            CreateField();

            while (true)
            {
                WriteField();

                MoveAE();

                //муравьед ест муравья
                foreach (var ant in ants.ToList())
                {
                    if (ant.X == aeX && ant.Y == aeY)
                    {
                        ants.Remove(ant);
                        score++;
                    }
                }

                //вывод препятсвий 
                foreach (var ob in obstacles)
                {
                    field[ob.Y, ob.X] = o;
                }

                //вывод муравьеда                    
                field[aeY, aeX] = 'O';

                //вывод муравеёников
                foreach (var ah in anthills)
                {
                    field[ah.Y, ah.X] = 'X';
                }

                GameEnd();

            }
        }

        static void WriteField()
        {
            //вывод массива
            for (int i = 0; i < height; i++)
            {
                for (int j = 0; j < width; j++)
                {
                    Console.SetCursorPosition(j, i);
                    Console.Write(field[i, j]);

                }
            }
        }

        static void FieldClear()
        {
            for (int i = 0; i < height; i++)
            {
                for (int j = 0; j < width; j++)
                {
                    field[i, j] = ' ';
                }
            }
        }

        static void Frame()
        {
            //добавление рамки
            for (int i = 0; i < height; i++)
            {
                for (int j = 0; j < width; j++)
                {
                    if (j == 0)
                    {
                        field[i, j] = v;
                    }
                    if (j == width - 1)
                    {
                        field[i, j] = v;
                    }
                    if (i == 0 && j % 2 == 0)
                    {
                        field[i, j] = v;
                    }
                    if (i == height - 1 && j % 2 == 0)
                    {
                        field[i, j] = v;
                    }
                }
            }
        }

        static void CreateField()
        {
            Random random = new Random();

            //добавление препятствий 
            int countOb = random.Next(3, 7); 
            for (int i = 0; i < countOb; i++)
            {
                int x = random.Next(1, width - 1); 
                int y = random.Next(1, height - 1); 
                obstacles.Add(new Obstacle(x, y)); 
            }
            

            //добавление муравьеда            
            aeX = random.Next(1, width - 1);
            aeY = random.Next(1, height - 1);

            field[aeY, aeX] = 'O';

            //добавление муравейников в список
            int nah = random.Next(1, 5);
            for (int i = 1; i <= nah; i++)
            {
                int x = random.Next(1, width - 1);

                int y = random.Next(1, height - 1);
                anthills.Add(new ah(x, y));
            }

            //добавление муравьев в список
            foreach (var ah in anthills)
            {
                for (int i = 0; i < random.Next(1, 11); i++)
                {
                    ants.Add(new Ant(ah.X, ah.Y));
                }
            }

            //добавление муравьёв для вывода
            foreach (var ant in ants)
            {
                field[ant.Y, ant.X] = '°';
            }

            //добавление муравейников для вывода
            foreach (var ah in anthills)
            {
                field[ah.Y, ah.X] = 'X';
            }
        }

        //перемещение муравьеда
        static void MoveAE()
        {
            //перемещение муравьеда
            if (Console.KeyAvailable)
            {
                field[aeY, aeX] = ' ';

                ConsoleKeyInfo key = Console.ReadKey(true);
                switch (key.Key)
                {
                    case ConsoleKey.UpArrow:
                        if (aeY > 1 && !colissOb(aeX, aeY-1)) aeY--;
                        break;
                    case ConsoleKey.DownArrow:
                        if (aeY < height - 2 && !colissOb(aeX, aeY+1)) aeY++;
                        break;
                    case ConsoleKey.LeftArrow:
                        if (aeX > 1 && !colissOb(aeX-1, aeY)) aeX--;
                        break;
                    case ConsoleKey.RightArrow:
                        if (aeX < width - 2 && !colissOb(aeX+1, aeY)) aeX++;
                        break;
                }
            }
        }

        static void GameEnd()
        {
            //подсчёт результатов
            if (ants.Count == 0)
            {
                Console.Clear();
                Console.WriteLine("Результат:" + score);
                Console.WriteLine("Нажмите клавишу Enter для завершения");
                Console.ReadLine();
                Environment.Exit(0);

            }
        }

        //таймер для изменения скорости передвижения муравьев
        static void StartTimer()
        {
            timerAnt = new System.Timers.Timer(200);
            timerAnt.Elapsed += OnTimerElapsed;
            timerAnt.AutoReset = true;
            timerAnt.Enabled = true;
        }

        //перемещение муравьев по таймеру
        static void OnTimerElapsed(object sender, ElapsedEventArgs e)
        {

            //удаление старого положени мравьев
            foreach (var ant in ants)
            {
                field[ant.Y, ant.X] = ' ';
            }

            Random random = new Random();
            //перемещение муравьев
            foreach (var ant in ants)
            {
                int direction = random.Next(4);
                switch (direction)
                {
                    case 0:
                        if (ant.Y > 0) ant.Y--;
                        break;
                    case 1:
                        if (ant.Y < height - 1) ant.Y++;
                        break;
                    case 2:
                        if (ant.X > 0) ant.X--;
                        break;
                    case 3:
                        if (ant.X < width - 1) ant.X++;
                        break;
                }
            }

            //удаление сбежавших муравьев
            ants.RemoveAll(ant => ant.X <= 1 || ant.X >= width - 1 || ant.Y <= 1 || ant.Y >= height - 1);

            //вывод муравьев
            foreach (var ant in ants)
            {
                field[ant.Y, ant.X] = '°';
            }
        }

        //проверка на столкновение с препятсвием
        static bool colissOb(int x, int y)
        {
            foreach (var ob in obstacles)
            {
                if (ob.X == x && ob.Y == y)
                {
                    return true;
                }
            }
            return false;
        }

        static void Menu()
        {
            int startY = (height - menu.Length) / 2-2;
            for (int i = 0; i < menu.Length; i++)
            {
                int startX = (width - menu[i].Length) / 2;
                for (int j = 0; j < menu[i].Length; j++)
                {
                    field[startY + i, startX + j] = menu[i][j];
                }
                startY++; // Переходим на следующую строку
            }
           
        }

        static void Rules()
        {
            int startY = (height - rules.Length) / 2;
            int startX = (width - rules[8].Length) / 2;
            for (int i = 0; i < rules.Length; i++)
            {
                for (int j = 0; j < rules[i].Length; j++)
                {
                    field[startY + i, startX + j] = rules[i][j];
                }
            }
        }

    }


    //класс для хранения муравейников
    class ah
    {
        public int X { get; }
        public int Y { get; }
        public ah(int x, int y)
        {
            X = x;
            Y = y;
        }
    }

    //класс для хранения муравьев
    class Ant
    {
        public int X { get; set; }
        public int Y { get; set; }
        public Ant(int x, int y)
        {
            X = x;
            Y = y;
        }
    }

    //класс для хранения препятсвий
    class Obstacle 
    {
        public int X { get; set; }
        public int Y { get; set; }
        public Obstacle(int x, int y)
        {
            X = x;
            Y = y;
        }
    }
}
